"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var app = require("tns-core-modules/application");
var Calendar = java.util.Calendar;
var RangeTimePickerDialog = (function (_super) {
    __extends(RangeTimePickerDialog, _super);
    function RangeTimePickerDialog(context, callBack, hourOfDay, minute, is24HourView) {
        var _this = _super.call(this, context, callBack, hourOfDay, minute, is24HourView) || this;
        _this.mMinHour = -1;
        _this.mMinMinute = -1;
        _this.mMaxHour = 100;
        _this.mMaxMinute = 100;
        _this.mCurrentHour = hourOfDay;
        _this.mCurrentMinute = minute;
        try {
            var superclass = _this.getClass().getSuperclass();
            var mTimePickerField = superclass.getDeclaredField("mTimePicker");
            mTimePickerField.setAccessible(true);
            var mTimePicker = mTimePickerField.get(_this);
            mTimePicker.setOnTimeChangedListener(_this);
        }
        catch (e) {
        }
        return _this;
    }
    RangeTimePickerDialog.prototype.setMin = function (hour, minute) {
        this.mMinHour = hour;
        this.mMinMinute = minute;
    };
    RangeTimePickerDialog.prototype.setMax = function (hour, minute) {
        this.mMaxHour = hour;
        this.mMaxMinute = minute;
    };
    RangeTimePickerDialog.prototype.onTimeChanged = function (view, hourOfDay, minute) {
        _super.prototype.onTimeChanged.call(this, view, hourOfDay, minute);
        var validTime;
        if (((hourOfDay < this.mMinHour) || (hourOfDay == this.mMinHour && minute < this.mMinMinute))
            || ((hourOfDay > this.mMaxHour) || (hourOfDay == this.mMaxHour && minute > this.mMaxMinute))) {
            validTime = false;
        }
        else {
            validTime = true;
        }
        if (validTime) {
            this.mCurrentHour = hourOfDay;
            this.mCurrentMinute = minute;
        }
        else {
            this.updateTime(this.mCurrentHour, this.mCurrentMinute);
        }
    };
    return RangeTimePickerDialog;
}(android.app.TimePickerDialog));
__decorate([
    Override,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", void 0)
], RangeTimePickerDialog.prototype, "onTimeChanged", null);
var ModalDatetimepicker = (function () {
    function ModalDatetimepicker() {
    }
    ModalDatetimepicker.prototype.pickDate = function (options) {
        return new Promise(function (resolve, reject) {
            if (options.startingDate && typeof options.startingDate.getMonth != 'function') {
                reject('startingDate must be a Date.');
            }
            if (options.minDate && typeof options.minDate.getMonth != 'function') {
                reject('minDate must be a Date.');
            }
            if (options.maxDate && typeof options.maxDate.getMonth != 'function') {
                reject('maxDate must be a Date.');
            }
            var startDate = new Date();
            if (options.startingDate)
                startDate = options.startingDate;
            try {
                var datePicker = new android.app.DatePickerDialog(app.android.foregroundActivity, new android.app.DatePickerDialog.OnDateSetListener({
                    onDateSet: function (view, year, monthOfYear, dayOfMonth) {
                        var date = {
                            "day": dayOfMonth,
                            "month": (++monthOfYear),
                            "year": year
                        };
                        resolve(date);
                    }
                }), startDate.getFullYear(), startDate.getMonth(), startDate.getDate());
                if (options.maxDate || options.minDate) {
                    var datePickerInstance = datePicker.getDatePicker();
                    if (options.maxDate)
                        datePickerInstance.setMaxDate(options.maxDate.getTime());
                    if (options.minDate)
                        datePickerInstance.setMinDate(options.minDate.getTime());
                }
                datePicker.show();
            }
            catch (err) {
                reject(err);
            }
        });
    };
    ModalDatetimepicker.prototype.pickTime = function (options) {
        options.is24HourView = options.is24HourView || false;
        return new Promise(function (resolve, reject) {
            var now = Calendar.getInstance();
            try {
                var timePicker = new RangeTimePickerDialog(app.android.foregroundActivity, new RangeTimePickerDialog.OnTimeSetListener({
                    onTimeSet: function (view, hourOfDay, minute) {
                        var time = {
                            "hour": hourOfDay,
                            "minute": minute
                        };
                        resolve(time);
                    }
                }), now.get(Calendar.HOUR_OF_DAY), now.get(Calendar.MINUTE), options.is24HourView);
                if (options.maxTime || options.minTime) {
                    if (options.maxTime)
                        timePicker.setMax(options.maxTime.hour, options.maxTime.minute);
                    if (options.minTime)
                        timePicker.setMin(options.maxTime.hour, options.maxTime.minute);
                }
                timePicker.show();
            }
            catch (err) {
                reject(err);
            }
        });
    };
    return ModalDatetimepicker;
}());
exports.ModalDatetimepicker = ModalDatetimepicker;
//# sourceMappingURL=modal-datetimepicker.android.js.map